include \masm32\include\masm32rt.inc

include include\lua.inc
include include\png.inc
include include\image.inc
include include\zlib.inc

includelib lib\lua51.lib
includelib lib\crc.lib
includelib lib\zdll.lib
includelib lib\png.lib
includelib lib\image.lib

debug macro params:vararg
	pushfd
	pushad
	% print params
	popad
	popfd
endm

.const

initfile	db	"init.lua", 0
fontfile	db	"make\font.lua", 0
fontimage	db	"make\font.png", 0
endfile		db	"end.lua", 0

filesdir	db	"make\", 0

outfile	db	"font.dgf", 0

imagecount	equ	05Fh

images	dd	offset image_0000
				dd	offset image_0001
				dd	offset image_0002
				dd	offset image_0003
				dd	offset image_0004
				dd	offset image_0005
				dd	offset image_0006
				dd	offset image_0007
				dd	offset image_0008
				dd	offset image_0009
				dd	offset image_000A
				dd	offset image_000B
				dd	offset image_000C
				dd	offset image_000D
				dd	offset image_000E
				dd	offset image_000F
				dd	offset image_0010
				dd	offset image_0011
				dd	offset image_0012
				dd	offset image_0013
				dd	offset image_0014
				dd	offset image_0015
				dd	offset image_0016
				dd	offset image_0017
				dd	offset image_0018
				dd	offset image_0019
				dd	offset image_001A
				dd	offset image_001B
				dd	offset image_001C
				dd	offset image_001D
				dd	offset image_001E
				dd	offset image_001F
				dd	offset image_0020
				dd	offset image_0021
				dd	offset image_0022
				dd	offset image_0023
				dd	offset image_0024
				dd	offset image_0025
				dd	offset image_0026
				dd	offset image_0027
				dd	offset image_0028
				dd	offset image_0029
				dd	offset image_002A
				dd	offset image_002B
				dd	offset image_002C
				dd	offset image_002D
				dd	offset image_002E
				dd	offset image_002F
				dd	offset image_0030
				dd	offset image_0031
				dd	offset image_0032
				dd	offset image_0033
				dd	offset image_0034
				dd	offset image_0035
				dd	offset image_0036
				dd	offset image_0037
				dd	offset image_0038
				dd	offset image_0039
				dd	offset image_003A
				dd	offset image_003B
				dd	offset image_003C
				dd	offset image_003D
				dd	offset image_003E
				dd	offset image_003F
				dd	offset image_0040
				dd	offset image_0041
				dd	offset image_0042
				dd	offset image_0043
				dd	offset image_0044
				dd	offset image_0045
				dd	offset image_0046
				dd	offset image_0047
				dd	offset image_0048
				dd	offset image_0049
				dd	offset image_004A
				dd	offset image_004B
				dd	offset image_004C
				dd	offset image_004D
				dd	offset image_004E
				dd	offset image_004F
				dd	offset image_0050
				dd	offset image_0051
				dd	offset image_0052
				dd	offset image_0053
				dd	offset image_0054
				dd	offset image_0055
				dd	offset image_0056
				dd	offset image_0057
				dd	offset image_0058
				dd	offset image_0059
				dd	offset image_005A
				dd	offset image_005B
				dd	offset image_005C
				dd	offset image_005D
				dd	offset image_005E
				dd	0

image_0000	db	"c20", 0
image_0001	db	"c21", 0
image_0002	db	"c22", 0
image_0003	db	"c23", 0
image_0004	db	"c24", 0
image_0005	db	"c25", 0
image_0006	db	"c26", 0
image_0007	db	"c27", 0
image_0008	db	"c28", 0
image_0009	db	"c29", 0
image_000A	db	"c2A", 0
image_000B	db	"c2B", 0
image_000C	db	"c2C", 0
image_000D	db	"c2D", 0
image_000E	db	"c2E", 0
image_000F	db	"c2F", 0
image_0010	db	"c30", 0
image_0011	db	"c31", 0
image_0012	db	"c32", 0 
image_0013	db	"c33", 0
image_0014	db	"c34", 0
image_0015	db	"c35", 0
image_0016	db	"c36", 0
image_0017	db	"c37", 0
image_0018	db	"c38", 0
image_0019	db	"c39", 0
image_001A	db	"c3A", 0
image_001B	db	"c3B", 0
image_001C	db	"c3C", 0
image_001D	db	"c3D", 0
image_001E	db	"c3E", 0
image_001F	db	"c3F", 0
image_0020	db	"c40", 0
image_0021	db	"c41", 0
image_0022	db	"c42", 0
image_0023	db	"c43", 0
image_0024	db	"c44", 0
image_0025	db	"c45", 0
image_0026	db	"c46", 0
image_0027	db	"c47", 0
image_0028	db	"c48", 0
image_0029	db	"c49", 0
image_002A	db	"c4A", 0
image_002B	db	"c4B", 0
image_002C	db	"c4C", 0
image_002D	db	"c4D", 0
image_002E	db	"c4E", 0
image_002F	db	"c4F", 0
image_0030	db	"c50", 0
image_0031	db	"c51", 0
image_0032	db	"c52", 0
image_0033	db	"c53", 0
image_0034	db	"c54", 0
image_0035	db	"c55", 0
image_0036	db	"c56", 0
image_0037	db	"c57", 0
image_0038	db	"c58", 0
image_0039	db	"c59", 0
image_003A	db	"c5A", 0
image_003B	db	"c5B", 0
image_003C	db	"c5C", 0
image_003D	db	"c5D", 0
image_003E	db	"c5E", 0
image_003F	db	"c5F", 0
image_0040	db	"c60", 0
image_0041	db	"c61", 0
image_0042	db	"c62", 0
image_0043	db	"c63", 0
image_0044	db	"c64", 0
image_0045	db	"c65", 0
image_0046	db	"c66", 0
image_0047	db	"c67", 0
image_0048	db	"c68", 0
image_0049	db	"c69", 0
image_004A	db	"c6A", 0
image_004B	db	"c6B", 0
image_004C	db	"c6C", 0
image_004D	db	"c6D", 0
image_004E	db	"c6E", 0
image_004F	db	"c6F", 0
image_0050	db	"c70", 0
image_0051	db	"c71", 0
image_0052	db	"c72", 0
image_0053	db	"c73", 0
image_0054	db	"c74", 0
image_0055	db	"c75", 0
image_0056	db	"c76", 0
image_0057	db	"c77", 0
image_0058	db	"c78", 0
image_0059	db	"c79", 0
image_005A	db	"c7A", 0
image_005B	db	"c7B", 0
image_005C	db	"c7C", 0
image_005D	db	"c7D", 0
image_005E	db	"c7E", 0

field_x				db	"x", 0
field_y				db	"y", 0
field_width		db	"width", 0
field_height	db	"height", 0

.data?

lstate	dd	?
imglist	dd	?
cbuffer	dd	?

tablebuffer	db	256 dup(?)

fontfilesize	dd	?
fontfiledata	dd	?

filenamebuffer	db	512 dup(?)

byteswritten	dd	?

fontdata		dd	?
fontwidth		dd	?
fontheight	dd	?
hfontimage	dd	?
fontbuffer	dd	?
fontsize		dd	?

ibytesread	dd	?

.code

start:
	; init png
	call pngInit
	
	; open lua
	call luaL_newstate
	mov lstate, eax
	
	; -- read lua files --
	
	; perform initialization
	push offset initfile
	push lstate
	call luaL_loadfile
	add esp, 8
	
	push 0
	push 0
	push lstate
	call lua_call
	add esp, 12
	
	; lua stack: [ ]
	
	; load file
	push offset fontfile
	push lstate
	call luaL_loadfile
	add esp, 8
	
	push -1
	push lstate
	call lua_type
	cmp eax, LUA_TSTRING
	jnz @F
	
	push 0
	push -1
	push lstate
	call lua_tolstring
	debug eax, 10
	
	push 0
	call ExitProcess
	
@@:
	
	push 0
	push 0
	push lstate
	call lua_call
	add esp, 12
	
	; lua stack: [ ]
	
	; finish
	push offset endfile
	push lstate
	call luaL_loadfile
	add esp, 8
	
	push -1
	push lstate
	call lua_type
	cmp eax, LUA_TSTRING
	jnz @F
	
	push 0
	push -1
	push lstate
	call lua_tolstring
	debug eax, 10
	
	push 0
	call ExitProcess
	
@@:
	
	push 0
	push 0
	push lstate
	call lua_call
	add esp, 12
	
	; lua stack: [ ]
	
	; -- done reading lua files --
	
	; -- read raw image --
	push NULL
	push FILE_ATTRIBUTE_NORMAL
	push OPEN_EXISTING
	push NULL
	push FILE_SHARE_READ
	push GENERIC_READ
	push offset fontimage
	call CreateFile
	mov hfontimage, eax
	
	cmp eax, INVALID_HANDLE_VALUE
	jnz @F
	
	print "Could not open font.png", 10
	
	push 0
	call ExitProcess
	
@@:
	
	push NULL
	push hfontimage
	call GetFileSize
	mov fontsize, eax
	
	push fontsize
	push LMEM_FIXED
	call LocalAlloc
	mov fontbuffer, eax
	
	push NULL
	push offset ibytesread
	push fontsize
	push fontbuffer
	push hfontimage
	call ReadFile
	
	push hfontimage
	call CloseHandle
	
	; read png file
	push fontbuffer
	call pngReadWidth
	add esp, 4
	mov fontwidth, eax
	
	debug "Source image width: "
	debug <ustr$(eax)>, 10
	
	push fontbuffer
	call pngReadHeight
	add esp, 4
	mov fontheight, eax
	
	debug "Source image height: "
	debug <ustr$(eax)>, 10
	
	mul fontwidth
	lea eax, [4*eax + 8]
	push eax
	push LMEM_FIXED
	call LocalAlloc
	mov fontdata, eax
	
	
	push ebx;
	
	push fontsize
	push fontbuffer
	push fontdata
	call pngReadData
	add esp, 12
	
	pop ebx;
	
	push fontbuffer
	call LocalFree
	
	; calculate file size
	call GetFontFileSize
	mov fontfilesize, eax
	
	debug "Font file size: "
	debug <ustr$(eax)>, 10
	
	push fontfilesize
	push LMEM_FIXED or LMEM_ZEROINIT
	call LocalAlloc
	mov fontfiledata, eax
	
	; -- write image data --
	
	mov esi, fontfiledata
	lea edi, [esi + 16 * imagecount]
	
	mov ebx, offset images
	
_buildloop:
	
;	debug "Build loop", 10
	
	; cut image
	mov eax, edi
	sub eax, fontfiledata
	mov [esi + 8], eax
	mov dword ptr [esi + 12], 0
	
	push edi				; dstdata
	
	push [ebx]
	call GetImageHeight
	push eax				; dstheight
	
	mov [esi + 4], eax
	
	cmp eax, 0
	jnz @F
	debug "Zero height image: "
	debug [ebx], 10
	
	push 0
	call ExitProcess
@@:
	
	push [ebx]
	call GetImageWidth
	push eax				; dstwidth
	
	mov [esi + 0], eax
	
	cmp eax, 0
	jnz @F
	debug "Zero width image: "
	debug [ebx], 10
	
	push 0
	call ExitProcess
@@:
	
	push [ebx]
	call GetImageY
;	debug "Y: "
;	debug <ustr$(eax)>, 10
	push eax				; y
	
	push [ebx]
	call GetImageX
;	debug "X: "
;	debug <ustr$(eax)>, 10
	push eax				; x
	
	push fontdata		; srcdata
	push fontheight	; srcheight
	push fontwidth	; srcwidth
	
	debug "Pushed cut image params", 10
	
	call ddCutImage
	
	debug "Image cut", 10
	
	cmp eax, 0
	jz @F
	
	debug "Error while cutting "
	debug [ebx]
	debug ": dimension out of bounds.", 10
	
@@:
	
;	debug "Width: "
;	mov eax, [esi + 0]
;	debug <ustr$(eax)>, 10
;	
;	debug "Height: "
;	mov eax, [esi + 4]
;	debug <ustr$(eax)>, 10
	
	mov eax, [esi + 0]
	mul dword ptr [esi + 4]
	lea edi, [edi + 4*eax]
	
	add esi, 16
	
	debug "Processed "
	debug [ebx], 10
	
	add ebx, 4
	cmp dword ptr [ebx], 0
	jnz _buildloop
	
	push fontfilesize
	push fontfiledata
	push offset outfile
	call writeCompressed
	
	debug "Done", 10
	
	push 0
	call ExitProcess
	
GetFontFileSize proc
	
	LOCAL result:dword
	LOCAL imgwidth:dword
	
	push esi
	push edi
	
	mov result, 16 * imagecount
	
	mov esi, offset images
	
_loop:
	push [esi]
	call GetImageWidth
	mov imgwidth, eax
	
	push [esi]
	call GetImageHeight
	mul imgwidth
	shl eax, 2
	
	add result, eax
	
	add esi, 4
	cmp byte ptr [esi], 0
	jnz _loop
	
	mov eax, result
	pop edi
	pop esi
	ret
	
GetFontFileSize endp


GetImageWidth proc imgname:dword
	
	LOCAL result:dword
	
;	debug "Image width", 10
	
	push imgname
	call GetImageTable
	
	push offset field_width
	push lstate
	call lua_pushstring
	add esp, 8
	
	push -2
	push lstate
	call lua_gettable
	add esp, 8
	
	push -1
	push lstate
	call lua_tonumber
	add esp, 8
	
	fistp result
	
	push -3
	push lstate
	call lua_settop
	add esp, 8
	
	mov eax, result
	ret
	
GetImageWidth endp

GetImageHeight proc imgname:dword
	
	LOCAL result:dword
	
;	debug "Image width", 10
	
	push imgname
	call GetImageTable
	
	push offset field_height
	push lstate
	call lua_pushstring
	add esp, 8
	
	push -2
	push lstate
	call lua_gettable
	add esp, 8
	
	push -1
	push lstate
	call lua_tonumber
	add esp, 8
	
	fistp result
	
	push -3
	push lstate
	call lua_settop
	add esp, 8
	
	mov eax, result
	ret
	
GetImageHeight endp

; -- get image x value --
GetImageX proc imgname:dword
	
	LOCAL result:dword
	
;	debug "Image X", 10
	
	push imgname
	call GetImageTable
	
	; lua stack: [ * | image info ]
	
	push offset field_x
	push lstate
	call lua_pushstring
	add esp, 8
	
	push -2
	push lstate
	call lua_gettable
	add esp, 8
	
	; lua stack: [ * | image info | x ]
	
	push -1
	push lstate
	call lua_tonumber
	add esp, 8
	
	fistp result
	
	push -3
	push lstate
	call lua_settop
	add esp, 8
	
	; lua stack: [ * ]
	
	mov eax, result
	ret
	
GetImageX endp

; -- get image y value --
GetImageY proc imgname:dword
	
	LOCAL result:dword
	
;	debug "Image Y", 10
	
	push imgname
	call GetImageTable
	
	push offset field_y
	push lstate
	call lua_pushstring
	add esp, 8
	
	push -2
	push lstate
	call lua_gettable
	add esp, 8
	
	push -1
	push lstate
	call lua_tonumber
	add esp, 8
	
	fistp result
	
	push -3
	push lstate
	call lua_settop
	add esp, 8
	
	mov eax, result
	ret
	
GetImageY endp

; -- get image info table --
GetImageTable proc imgname:dword
	
	LOCAL done
	
	push esi
	push edi
	
;	debug imgname, 10
	
	mov done, 0
	
	; make internal copy
	mov esi, imgname
	mov edi, offset tablebuffer
	
@@:
	movzx eax, byte ptr [esi]
	mov [edi], al
	add esi, 1
	add edi, 1
	
	cmp eax, 0
	jnz @B
	
	mov esi, offset tablebuffer
	mov edi, esi
	
	push LUA_GLOBALSINDEX
	push lstate
	call lua_pushvalue
	add esp, 8
	
_loop:
	movzx eax, byte ptr [esi]
	
	add esi, 1
	cmp eax, '.'
	jz @F
	
	cmp eax, 0
	jz _last
	
	jmp _loop
	
_last:
	mov done, 1
	
@@:
	mov byte ptr [esi-1], 0
	
;	debug "Table: ["
;	debug edi, ']', 10
	
	push edi
	push lstate
	call lua_pushstring
	add esp, 8
	
	push -2
	push lstate
	call lua_gettable
	add esp, 8
	
	push -1
	push lstate
	call lua_type
	add esp, 8
	
	cmp eax, LUA_TNIL
	jz _invalid
	
	; remove old table
	push -2
	push lstate
	call lua_replace
	add esp, 8
	
	mov edi, esi
	
	cmp done, 1
	jnz _loop
	
_end:
	pop edi 
	pop esi
	ret
	
_invalid:
	print "Error: image "
	print imgname
	print " does not exist.", 10
	
	push 0
	call ExitProcess
	
	pop edi
	pop esi
	ret
	
GetImageTable endp

writeCompressed proc filename:dword, filedata:dword, _filesize:dword
	
	LOCAL buffer:dword
	LOCAL zstrm:z_stream
	LOCAL hfile:dword
	
	push esi
	push edi
	
	debug "Writing compressed file...", 10
	
	push NULL
	push FILE_ATTRIBUTE_NORMAL
	push CREATE_ALWAYS
	push NULL
	push 0
	push GENERIC_WRITE
	push filename
	call CreateFile
	cmp eax, 0
	jnz @F
	
	debug "Can't create output file", 10
	push 0
	call ExitProcess
	
@@:
	mov hfile, eax
	
	debug "Created file", 10
	
	push NULL
	push offset byteswritten
	push 4
	lea eax, _filesize
	push eax
	push hfile
	call WriteFile
	
	debug "Wrote size", 10
	
	push 16384
	push LMEM_FIXED
	call LocalAlloc
	mov buffer, eax
	
	debug "Allocated memory: "
	debug <hex$(eax)>, 10
	
	mov zstrm.zalloc, 0
	mov zstrm.zfree, 0
	
	mov zstrm.data_type, Z_BINARY
	
	debug "Initializing deflate", 10
	
	push sizeof z_stream
	push offset ZLIB_VERSION
	push Z_BEST_COMPRESSION
	lea eax, zstrm
	push eax
	call deflateInit_
	add esp, 16
	
	debug "Initialized deflate", 10
	
	mov eax, filedata
	mov zstrm.next_in, eax
	mov eax, _filesize
	mov zstrm.avail_in, eax
	
	mov eax, buffer
	mov zstrm.next_out, eax
	mov zstrm.avail_out, 16384
	
	; compress in chunks of 16K
_writeloop:
	push Z_NO_FLUSH
	lea eax, zstrm
	push eax
	call deflate
	add esp, 8
	
	debug "deflate", 10
	
	debug "Return code: "
	debug <str$(eax)>, 10
	
;	cmp zstrm.avail_in, 0
;	jz _lastblock
	jmp _lastblock
	
	push NULL
	push offset byteswritten
	push 16384
	push buffer
	push hfile
	call WriteFile
	
	mov eax, buffer
	mov zstrm.next_out, eax
	mov zstrm.avail_out, 16384
	
	jmp _writeloop
	
_lastblock:
	push Z_FINISH
	lea eax, zstrm
	push eax
	call deflate
	add esp, 8
	
	cmp eax, Z_STREAM_END
	jz _cdone
	
	push NULL
	push offset byteswritten
	push 16384
	push buffer
	push hfile
	call WriteFile
	
	mov eax, buffer
	mov zstrm.next_out, eax
	mov zstrm.avail_out, 16384
	
	jmp _lastblock
	
_cdone:
	mov eax, 16384
	sub eax, zstrm.avail_out
	cmp eax, 0
	jz _done
	
	push NULL
	push offset byteswritten
	push eax
	push buffer
	push hfile
	call WriteFile
	
_done:
	push hfile
	call CloseHandle
	
	lea eax, zstrm
	push eax
	call deflateEnd
	
	pop edi
	pop esi
	ret
	
writeCompressed endp

end start
