; ZLIB include file for MASM32

ZLIB_VERNUM	equ	01230h

.data
ZLIB_VERSION	db "1.2.3", 0

z_stream STRUCT
	next_in		DWORD	?
	avail_in	DWORD	?
	total_in	DWORD	?
	
	next_out	DWORD	?
	avail_out	DWORD	?
	total_out	DWORD	?
	
	msg				DWORD	?
	state			DWORD	?
	
	zalloc		DWORD	?
	zfree			DWORD	?
	opaque		DWORD	?
	
	data_type	DWORD	?
	adler			DWORD	?
	reserved	DWORD	?
z_stream ENDS

gz_header_s STRUCT

	text			DWORD	?
	time			DWORD	?
	xflags		DWORD	?
	os				DWORD	?
	extra			DWORD	?
	extra_len	DWORD	?
	extra_max	DWORD	?
	name			DWORD	?
	name_max	DWORD	?
	comment		DWORD	?
	comm_max	DWORD	?
	hcrc			DWORD	?
	done			DWORD	?

gz_header_s ENDS

Z_NO_FLUSH      equ 0
Z_PARTIAL_FLUSH equ 1 ; will be removed, use Z_SYNC_FLUSH instead
Z_SYNC_FLUSH    equ 2
Z_FULL_FLUSH    equ 3
Z_FINISH        equ 4
Z_BLOCK         equ 5

Z_OK            equ 0
Z_STREAM_END    equ 1
Z_NEED_DICT     equ 2
Z_ERRNO       	equ (-1)
Z_STREAM_ERROR	equ (-2)
Z_DATA_ERROR  	equ (-3)
Z_MEM_ERROR   	equ (-4)
Z_BUF_ERROR   	equ (-5)
Z_VERSION_ERROR equ (-6)

Z_NO_COMPRESSION       equ   0
Z_BEST_SPEED           equ   1
Z_BEST_COMPRESSION     equ   9
Z_DEFAULT_COMPRESSION  equ (-1)

Z_FILTERED            equ 1
Z_HUFFMAN_ONLY        equ 2
Z_RLE                 equ 3
Z_FIXED               equ 4
Z_DEFAULT_STRATEGY    equ 0

Z_BINARY   equ 0
Z_TEXT     equ 1
Z_UNKNOWN  equ 2

Z_DEFLATED equ 8

zlibVersion PROTO C

deflateInit_ PROTO C :DWORD, :DWORD, :DWORD, :DWORD
deflate PROTO C :DWORD, :DWORD
deflateEnd PROTO C :DWORD

inflateInit_ PROTO C :DWORD, :DWORD, :DWORD
inflate PROTO C :DWORD, :DWORD
inflateEnd PROTO C :DWORD

deflateInit2 PROTO C :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
deflateSetDictionary PROTO C :DWORD, :DWORD, :DWORD
deflateCopy PROTO C :DWORD, :DWORD
deflateReset PROTO C :DWORD
deflateParams PROTO C :DWORD, :DWORD, :DWORD
deflateTune PROTO C :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
deflateBound PROTO C :DWORD, :DWORD
deflatePrime PROTO C :DWORD, :DWORD, :DWORD
deflateSetHeader PROTO C :DWORD, :DWORD

inflateInit2 PROTO C :DWORD, :DWORD
inflateSetDictionary PROTO C :DWORD, :DWORD, :DWORD
inflateSync PROTO C :DWORD
inflateCopy PROTO C :DWORD, :DWORD
inflateReset PROTO C :DWORD
inflatePrime PROTO C :DWORD, :DWORD, :DWORD
inflateGetHeader PROTO C :DWORD, :DWORD

inflateBackInit PROTO C :DWORD, :DWORD, :DWORD
inflateBack PROTO C :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
inflateBackEnd PROTO C :DWORD

zlibCompileFlags PROTO C
compress PROTO C :DWORD, :DWORD, :DWORD, :DWORD
compress2 PROTO C :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
compressBound PROTO C :DWORD
uncompress PROTO C :DWORD, :DWORD, :DWORD, :DWORD

gzopen PROTO C :DWORD, :DWORD
gzdopen PROTO C :DWORD, :DWORD
gzsetparams PROTO C :DWORD, :DWORD, :DWORD
gzread PROTO C :DWORD, :DWORD, :DWORD
gzwrite PROTO C :DWORD, :DWORD, :DWORD
gzprintf PROTO C :DWORD, :VARARG
gzputs PROTO C :DWORD, :DWORD
gzgets PROTO C :DWORD, :DWORD, :DWORD
gzputc PROTO C :DWORD, :DWORD
gzgetc PROTO C :DWORD
gzungetc PROTO C :DWORD, :DWORD
gzflush PROTO C :DWORD, :DWORD
gzseek PROTO C :DWORD, :DWORD, :DWORD
gzrewind PROTO C :DWORD
gztell PROTO C :DWORD
gzeof PROTO C :DWORD
gzdirect PROTO C :DWORD
gzclose PROTO C :DWORD
gzerror PROTO C :DWORD, :DWORD
gzclearerr PROTO C :DWORD

adler32 PROTO C :DWORD, :DWORD, :DWORD
adler32_combine PROTO C :DWORD, :DWORD, :DWORD

crc32 PROTO C :DWORD, :DWORD, :DWORD
crc32_combine PROTO C :DWORD, :DWORD, :DWORD
